-- buf_gen.adb
-- rodzajowa (generyczna) wersja bufora 
-- Materiały dydaktyczne
-- Jacek Piwowarczyk 2021

package body Buf_Gen is

-- obiekt chroniony 
protected body BufT is
 entry Wstaw(Ch : in Typ_Elementu)
  when LiczElem<Rozmiar is
 begin
   B(LiczWstaw) := Ch;
   LiczWstaw := LiczWstaw mod Rozmiar + 1;
   LiczElem := LiczElem+1;
 end Wstaw;
 entry Pobierz(Ch: out Typ_Elementu)
  when LiczElem>0 is
 begin
   Ch := B(LiczPob);
   LiczPob := LiczPob mod Rozmiar + 1;
   LiczElem := LiczElem-1;
 end Pobierz;
end BufT;

end Buf_Gen;