-- buf_gen.ads
-- rodzajowa (generyczna) wersja bufora 
-- Materiały dydaktyczne
-- Jacek Piwowarczyk 2021

generic 
  Rozmiar: Natural;
  type Typ_Elementu is (<>);-- private;
package Buf_Gen is

type TBuf is array(Integer range 1..Rozmiar) of Typ_Elementu;

-- obiekt chroniony 
protected type BufT is
-- bufor ograniczony
 entry Wstaw(Ch : in Typ_Elementu);
 entry Pobierz(Ch : out Typ_Elementu);
private
 B : TBuf;
 LiczElem  : Integer:=0;
 LiczPob   : Integer:=1;
 LiczWstaw : Integer:=1;
end BufT;

end Buf_Gen;