-- pzdziel.ads
-- Materiały dydaktyczne
-- Jacek Piwowarczyk 2021

with Ada.Text_IO;
use Ada.Text_IO;
with Ada.Real_Time;
use Ada.Real_Time;

package Pzdziel is
	
  Koniec : Boolean := False with Atomic;	

  Dana: Float := 0.0 with Atomic;
  
  type Punkt is record
    X, Y : Float := 0.0;
  end record;
  
  protected Zasob is
    procedure Wstaw(D: in Punkt);
    procedure Pobierz(D: out Punkt);
    function Pobierz return Punkt;
  private
    Dan : Punkt := (0.0, 0.0);  
  end Zasob;  

  protected Ekran is
    procedure Pisz(S : String);
  end Ekran;

  task Prod1;
  
  task Prod2;
  
  task Kons;

end Pzdziel;
