-- tgenbuf.adb
-- komunikacja asynchroniczna przez bufor
-- kolejka FIFO
-- Materiały dydaktyczne
-- Jacek Piwowarczyk 2021

with Ada.Text_IO, Buf_Gen;
use Ada.Text_IO;

procedure TGenBuf is
  
  package BufR is new Buf_Gen(20, Character);
  use BufR;
  
  Buf : BufT;
  
task Producent; 

task body Producent is
  Cl : Character := 's';
begin  
  Put_Line("$ wstawiam: znak = '" & Cl & "'");
  Buf.Wstaw(Cl);
  Put_Line("$ wstawiłem...");
end Producent;

task Konsument; 

task body Konsument is
  Cl : Character := ' ';
begin  
  Put_Line("# pobiorę...");
  Buf.Pobierz(Cl);
  Put_Line("# pobrałem: znak = '" & Cl & "'");
end Konsument;

begin
  Put_Line("@ jestem w procedurze glownej");
end TGenBuf;
  